<template>
  <el-form :model="form" label-width="120px" :rules="rules" ref="ruleForm">
    <el-form-item label="Project" prop="project"  >
      <el-select v-model="form.project" placeholder="please select project" :disabled="propsID?true:false">
        <el-option v-for="(item) in taskProject" :key="item.id" :value="item.id" :label="item.project" :disabled="form.status==1" ></el-option>
      </el-select>
    </el-form-item>
    <el-form-item label="User" prop="user"  >
      <el-select v-model="form.user" placeholder="please select user" :disabled="propsID?true:false">
        <el-option v-for="(item) in taskUser" :key="item.id" :value="item.id" :label="item.name" :disabled="form.status==1"  ></el-option>
      </el-select>
    </el-form-item>
    <el-form-item label=Status  >
        <el-tag
          :type="form.status==0?'infor':form.status==1?'success':'warning'"
          disable-transitions
        >
          {{form.status==0?"Request":form.status==1?"Approve":"Reject"}}
        </el-tag>
    </el-form-item>
    <el-form-item label="Start at" prop="startAt"  class="comment" >
      <el-col>
        <el-date-picker  type="datetime" placeholder="Pick a date" v-model="form.startAt" :disabled="form.status==1" ></el-date-picker>
      </el-col>
    </el-form-item>
    <el-form-item label="End at" prop="endAt" >
      <el-col>
        <el-date-picker type="datetime"  placeholder="Pick a date" v-model="form.endAt" :disabled="form.status==1" ></el-date-picker>
      </el-col>
    </el-form-item>
    <el-form-item label="Time ot" prop="timeOt" >
      <el-col :span="2" ><div class="grid-content bg-purple"><el-input type="text" v-model="form.timeOt" :disabled="form.status==1" ></el-input></div></el-col>
      <span style="padding-left: 10px;">Hours</span> <span  style="padding-left: 50px;">(Min: 2 hours - Max: 24 hours) </span>
    </el-form-item>
    <el-form-item label="Reason" prop="reason">
        <el-input
        class="comment"
        type="textarea"
        :autosize="{ minRows:4, maxRows: 10}"
        placeholder="Enter reason..."
        v-model="form.reason"
        ></el-input>
    </el-form-item>
    <el-form-item :hidden="show" label="Commnets">
        <el-input class="comment"
        type="textarea"
      :autosize="{ minRows:4, maxRows: 10}"
        placeholder="Enter commnets..."
        v-model="form.comment"
        ></el-input>
    </el-form-item>
    <el-form-item >
      <span v-if='propsID'>
        <el-button  :disabled="form.status==1" type="success" @click="changeStatus(form.id,1)" >Approve</el-button>
        <el-button :disabled="form.status==2" type="warning" @click="changeStatus(form.id,2)">Reject</el-button>
      </span>
      <el-button type="primary" @click="saveOT('ruleForm')"><i class="el-icon-save"></i> Save</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
import callApi from '../middleware/apiCaller.js'
var dateFormat = require('dateformat');
var moment = require('moment');
    export default {
      data() {
        return {
          form:{
            id: null,
            project:'',
            user:'',
            status:null,
            startAt:moment().format('YYYY-MM-DD 18:00:00'),
            endAt:moment().format('YYYY-MM-DD 20:00:00'),
            timeOt: '',
            reason:'',
            comment:'',
          },
          items:[],
          taskProject:[],
          taskUser:[],
          show:true,
          disabale:false,
        }
      },

      props:['propsID', ],
         
      computed:{
        rules() {

          var isFloat = (n) => {
            return n === +n && n !== (n|0);
          }

          var checkTime = (rule, value, callback) =>{

            if (isNaN(value)) {
              return callback(new Error('Please input the time over time'));
            }

            if (isFloat(value)) {
              callback(new Error('Please input digits '));
            } else {
              if (value < 2 || value > 24) {
                callback(new Error('Time over between 2 to 24'));
              } 
              else {
                callback();
              }
            }
          }

          var checkStartat = (rule, value, callback) => {

            var today = moment().format('YYYY-MM-DD')
            let dateStart= moment(this.form.startAt)
            if(dateStart.isBefore(today)){
              return callback(new Error('Please choose date present'))
            }
            callback()

          }

            var checkEndat = (rule, value, callback) =>{

              let dateStart2 = moment(this.form.startAt)
              var dateEnd = moment(this.form.endAt)
              if(!dateEnd.isAfter(dateStart2)){
                return callback(new Error('Please choose date present or the next day'))
              }
              if(dateEnd.isBefore(dateStart2)){
                return callback(new Error('Please choose date present or the next day'))
              }
              callback()
            }

            const rules = {

              project: [
                {required: true, message: 'Please select event project', trigger: 'change'}
              ],
              user:[
                {required: true, message:'Please select event user', trigger:'change'}
              ],
              startAt:[
                { validator: checkStartat, trigger:'blur'}
              ],
              endAt:[
                { validator: checkEndat, trigger:'blur'}
              ],
              timeOt:[
                { validator: checkTime, trigger:'blur'}
              ],
              reason:[
                {trigger:"blur"}
              ]
            }
            return rules
          },

          //setData for put and post up server
          setData(){
            return{

              id:'',
              project:this.form.project,
              user:this.form.user,
              status:this.form.status,
              startat:moment(this.form.startAt).format("YYYY-MM-DD HH:mm "),// function format  date
              endat:moment(this.form.endAt).format("YYYY-MM-DD HH:mm "),// function format  date
              timeot:this.form.timeOt,
              reason:this.form.reason,
              comment:this.form.comment,

            }
          }
        },

      methods: {
        // function c
        changeStatus(id,status){
        let data = this.setData
        data.status = status

        callApi('overtime/'+id, 'GET',null).then(res =>{

            this.taskId=res.data,
            this.project=this.taskId.project,
            this.user=this.taskId.user,
            this.startat=this.taskId.startat,
            this.endat=this.taskId.endat,
            this.timeot=this.taskId.timeot,
            this.reason=this.taskId.reason,
            this.comment=this.taskId.comment

            if(status==1){
              callApi('overtime/'+id,'PUT',data).then(res =>{
                this.$message({
                  type:"success",
                  message: "Approve completed"
                }),
                this.$emit('search')
               this.$router.push({path:'/overtime'})
              }
              )
            }
            else
            {
              callApi('overtime/'+id,'PUT',data).then(res =>{
                this.$message({
                    type:"warning",
                    message: "Reject completed"
                }),
                this.$emit('search')
                this.$router.push({path:'/overtime'})
              })
            }
          })
        },

        // funtion notification of event save
        comfirm(endpoint,method,data){
          return(

            this.$confirm('This will permanently save the data. Continue?', 'Save', {
              confirmButtonText: 'OK',
              cancelButtonText: 'Cancel',
              type: 'success'
            }).then(() => {
                callApi(endpoint,method,data).then(res =>{
                  this.$message({
                    type: 'success',
                    message: 'Save completed'
                    })
                })
                this.$router.push({path:'/overtime'})
              }).catch(() => {
                  this.$message({
                    type: 'info',
                    message: 'Save canceled'
                  });          
                })
          )
        },

          // button save
        saveOT(formName){
            
          this.$refs[formName].validate((valid) => {
            if (valid) {
              if(this.propsID){
                this.comfirm('overtime/'+this.propsID,'PUT',this.setData)
              }
              else{
                this.comfirm('overtime','POST',this.setData,'')
              }
            }
          });

        },
      },

      mounted() {

          //call api theo id
        if(this.propsID){
          this.show=false
          // this.disabale=true
          callApi('overtime/'+this.propsID, 'GET').then(res =>{
            this.items=res.data
            this.form.id=this.items.id
            this.form.project=this.items.project,
            this.form.user=this.items.user
            this.form.startAt=this.items.startat
            this.form.endAt=this.items.endat
            this.form.timeOt=this.items.timeot
            this.form.status=this.items.status
            this.form.reason=this.items.reason
            this.form.comment=this.comment
          })
        }
          callApi('overtime','GET').then(res =>{
            this.items=res.data
          })

          callApi('project','GET').then(res =>{
            this.taskProject = res.data
          })

          callApi('user','GET').then(res =>{
            this.taskUser = res.data
          })
            
        },
    }
</script>

<style lang="css" scoped>
.comment{
  width:60%;
}
.el-button{
  margin-left:0px;
}
</style>